/*
 * fasta_sequence_reader.h
 *
 *  Created on: 2009/06/19
 *      Author: shu
 */

#ifndef UUID_86BDE687_BFCF_4607_83A3_47C60321415D
#define UUID_86BDE687_BFCF_4607_83A3_47C60321415D

#include <ios>
#include <string>
#include <sstream>
#include <mpi.h>
#include "sequence.h"
#include "ghostmp_sequence_reader.h"
#include "ghostmp_mpi_util.h"

class FastaSequenceReader: public SequenceReader {
public:
  // constructor
  FastaSequenceReader(const char* file_name) {
    {
      std::string buffer;
      int rc = ghostmp::read_fasta(file_name, buffer, MPI_COMM_WORLD);
      if (rc == 1) {
        throw std::ios_base::failure("could not open file:" + std::string(file_name));
      } else if (rc == 2) {
        throw std::ios_base::failure("could not find biginning of fasta entries.\n"
            "There will be relatively longer sequences or too few sequences compared to # of processes.");
      }
      in_.str(buffer);
    }
    last_line_ = "";
  }

  // destructor
  ~FastaSequenceReader() {
  }

  SequencePtr Read();
private:

  std::istringstream in_;
  std::string last_line_; // last input line
};

#endif
